# A widget for taking inputs for getGEOSAGE.
#
# Copyright 2003, J. Zhang, all rights reserved
#

GEOSAGEWidget <- function(){
    on.exit(end())

    orgVar <- tclVar("human")
    targetVar <- tclVar(file.path(.path.package("SAGElyzer"), "temp"))
    urlVar <- tclVar("http://www.ncbi.nlm.nih.gov/geo/query/acc.cgi?")
    END <- TRUE

    end <- function(){
        tkdestroy(base)
    }
    cancel <- function(){
        END <<- FALSE
        end()
    }
    getTargetDir <- function(){
        targetVar <- fileBrowser(nSelect = 1)
        writeList(targetEntry, targetVar, TRUE)
    }


    base <- tktoplevel()
    tktitle(base) <- "BioC SAGElyzer"

    label1 <- tklabel(base, text = "Organism")
    orgEntry <- tkentry(base, width = 15, textvariable = orgVar)
    tkgrid(label1, orgEntry, padx = 5)


    label2 <- tklabel(base, text = "Save To")
    targetFrame <- tkframe(base)
    targetEntry <- tkentry(targetFrame, width = 50, textvariable = targetVar)
    tkpack(targetEntry, side = "left", expand = TRUE, fill = "x")
    targetBut <- tkbutton(targetFrame, width = 6, text = "Browse",
                                            command = getTargetDir)
    tkpack(targetBut, side = "left")
    tkgrid(label2, targetFrame, padx = 5)

    label3 <- tklabel(base, text = "Source URL")
    urlEntry <- tkentry(base, width = 50, textvariable = urlVar)
    tkgrid(label3, urlEntry, padx = 5)

    tkgrid.configure(label1, label2, label3, sticky = "e")
    tkgrid.configure(orgEntry, targetFrame, urlEntry, sticky = "w")
    butFrame <- tkframe(base)
    cancelBut <- tkbutton(butFrame, text = "Cancel", width = 8,
                          command = cancel)
    endBut <- tkbutton(butFrame, text = "Continue", width = 8, command = end)
    tkpack(endBut, cancelBut, side = "left", padx = 20)
    tkgrid(butFrame, columnspan = 2, pady = 5)

    tkwait.window(base)

    if(END){
        return(list(organism = tclvalue(orgVar),
                targetDir = tclvalue(targetVar), url = tclvalue(urlVar)))
    }else{
        return(NULL)
    }
}

