SAGE4Unix <- function(){
    on.exit(end())

    setSLyzerArgs()

    end <- function(){
        tkdestroy(base)
    }
    getHelp <- function(){
        writeText(textBox, help, TRUE)
    }
    queryGEO <- function(){
#        tkconfigure(SAGEMenu, state = "disabled")
        writeText(textBox, "Getting libraries from GEO ...", TRUE)
        done <- SAGEFromGEO()
        writeText(textBox, done, FALSE)
#        tkconfigure(SAGEMenu, state = "normal")
    }
    mergeLibs <- function(){
#        tkconfigure(SAGEMenu, state = "disabled")
        writeText(textBox, "Merging SAGE libraries ...", TRUE)
        done <- procSAGE()
        writeText(textBox, done, FALSE)
#        tkconfigure(SAGEMenu, state = "normal")
    }
    runSAGELyzer <- function(){
#        tkconfigure(SAGEMenu, state = "disabled")
        writeText(textBox, "Calculating distances ...", TRUE)
        runSLyzer()
        writeText(textBox, "Done", FALSE)
#        tkconfigure(SAGEMenu, state = "normal")
    }
    findMapping <- function(){
#        tkconfigure(SAGEMenu, state = "disabled")
        writeText(textBox, "Mapping SAGE tags ...", TRUE)
        done <- mapSAGE2UG()
        writeText(textBox, done, FALSE)
#        tkconfigure(SAGEMenu, state = "normal")
    }

    base <- tktoplevel()
    tktitle(base) <- "BioC SAGElyzer"

    text <- paste("SAGElyzer: a package for the integration, analysis,",
                  "and annotation of expression data")
    help <- paste("Click the \"SAGElyzer\" menu bar to select executable",
                  "functions.")

    textBox <- tktext(base, width = 45, height = 10, wrap = "word")
    writeText(textBox, text, TRUE)
    tkpack(textBox, side = "top", padx = 10, pady = 5)

    endBut <- tkbutton(base, text = "Exit", width = 8, command = end)
    tkpack(endBut, side = "top", padx = 10, pady = 5)

    topMenu <- tkmenu(base)
    tkconfigure(base, menu = topMenu)

    SAGEMenu <- tkmenu(topMenu, tearoff = FALSE)
    # Set the menu for making connections to DB
    tkadd(SAGEMenu, "command", label = "DBConnecter", command = getDBArgs)
    # Set the menu for data integration
    mergerMenu <- tkmenu(SAGEMenu, tearoff = FALSE)
#    tkadd(mergerMenu, "command", label = "Connect to DB",
#          command = getCountsDBArgs)
    tkadd(mergerMenu, "command", label = "Get GEOSAGE", command =queryGEO)
    tkadd(mergerMenu, "command", label = "Integrate SAGE",
                                                 command = mergeLibs)
    tkadd(mergerMenu, "command", label = "Map SAGE", command = findMapping)
    tkadd(SAGEMenu, "cascade", label = "SAGEIntegrater", menu = mergerMenu)
    # Set the menu for SAGELyzer
    lyzerMenu <- tkmenu(SAGEMenu, tearoff = FALSE)
#    tkadd(lyzerMenu, "command", label = "Connect to DB",
#          command = getCountsDBArgs)
    tkadd(lyzerMenu, "command", label = "Set Target", command = getTag)
    tkadd(lyzerMenu, "command", label = "Select Libs", command = selectLibs)
    tkadd(lyzerMenu, "command", label = "Reset Defaults",
                                                 command = getDefaults)
    tkadd(lyzerMenu, "command", label = "Run", command = runSAGELyzer)
    tkadd(lyzerMenu, "command", label = "Get Lib Counts",
                                                 command = getLibCounts)
    tkadd(lyzerMenu, "command", label = "View Libs", command = mapLib2File)
    tkadd(lyzerMenu, "command", label = "Annotate Tags", command = linkTag2UG)
#    tkadd(lyzerMenu, "command", label = "Reset", command = setSLyzerArgs)
    tkadd(SAGEMenu, "cascade", label = "SAGELyzer", menu = lyzerMenu)
    # Set the menu for mapping SAGE data
#    mapperMenu <- tkmenu(SAGEMenu, tearoff = FALSE)
#    tkadd(mapperMenu, "command", label = "Connect to DB",
#          command = getMapDBArgs)
#    tkadd(mapperMenu, "command", label = "Annotate Tags",
#          command = linkTag2UG)
#    tkadd(SAGEMenu, "cascade", label = "SAGEMapper", menu = mapperMenu)

    tkadd(topMenu, "cascade", label = "SAGE", menu = SAGEMenu)
    tkadd(topMenu, "command", label = "Help", command = getHelp)

    tkwait.window(base)
}
