# A widget for taking inputs for mergeSAGE.
#
# Copyright 2003, J. Zhang, all rights reserved
#

mapSAGEWidget <- function(){
    on.exit(end())

    tableVar <- tclVar("tagugmap")
    mapVar <- tclVar("TRUE")
    if(.Platform$OS.type == "unix"){
        urlVar <- tclVar(paste("ftp://ftp.ncbi.nih.gov/pub/sage/map/Hs/",
                           "NlaIII/SAGEmap_tag_ug-rel.zip", sep = ""))
    }else{
        urlVar <- ""
    }
    args <- NULL
    END <- TRUE
    end <- function(){
        if(END){
            tempArgs <- getSLyzerArgs()
            tempArgs$dbArgs$tableName <- tclvalue(tableVar)
            modSLyzerArgs("dbArgs", tempArgs$dbArgs)
            if(class(urlVar) == "tclVar"){
                urlVar <- tclvalue(urlVar)
            }
            if(class(mapVar) == "tclVar"){
                mapVar <- tclvalue(mapVar)
            }
            args <<- list(tag2UG = as.logical(mapVar),
                         tagUrl = urlVar)
        }
        tkdestroy(base)
    }
    cancel <- function(){
        END <<- FALSE
        end()
    }
    setDB <- function(){
        getDBArgs()
        tableVar <<- getSLyzerArgs()$dbArgs$tableName
        writeList(tableEntry, tableVar, TRUE)
    }
    getSrcData <- function(){
        urlVar <<- tclvalue(tkgetOpenFile())
        writeList(urlEntry, urlVar)
    }

    base <- tktoplevel()
    tktitle(base) <- "BioC SAGElyzer"

    label2 <- tklabel(base, text = "DB Table Name")
    tableFrame <- tkframe(base)
    tableEntry <- tkentry(tableFrame, width = 50, textvariable = tableVar)
    tkpack(tableEntry, side = "left", expand = TRUE, fill = "x")
    resetBut <- tkbutton(tableFrame, width = 8, text = "Reset",
                                                 command = setDB)
    tkpack(resetBut, side = "left")
    tkgrid(label2, tableFrame, padx = 5)

    label1 <- tklabel(base, text = "Map")
    mapFrame <- tkframe(base)
    trueRad <- tkradiobutton(mapFrame, text = "Tag to UG",
                             variable = mapVar, value = "TRUE")
    falseRad <- tkradiobutton(mapFrame, text = "UG to Tag",
                              variable = mapVar, value = "FALSE")
    tkpack(trueRad, falseRad, side = "left")
    tkgrid(label1, mapFrame, padx = 5)

    urlFrame <- tkframe(base)
    if(.Platform$OS.type == "windows"){
        urlText <- "Source data"
    }else{
        urlText <- "Source URL"
    }
    label3 <- tklabel(base, text = urlText)
    urlEntry <- tkentry(urlFrame, width = 50, textvariable = urlVar)
    urlBut <- tkbutton(urlFrame, width = 8, text = "browse",
                       command = getSrcData)
    tkpack(urlEntry, side = "left", expand = TRUE, fill = "x")
    tkpack(urlBut, side = "left", expand = FALSE)
    tkgrid(label3, urlFrame, padx = 5)

    tkgrid.configure(label1, label2, label3, sticky = "e")
    tkgrid.configure(tableFrame, mapFrame, urlFrame, sticky = "w")
    butFrame <- tkframe(base)
    endBut <- tkbutton(butFrame, text = "Continue", width = 8, command = end)
    cancelBut <- tkbutton(butFrame, text = "Cancel", width = 8,
                                                     command = cancel)
    tkpack(endBut, cancelBut, side = "left", padx = 20)
    tkgrid(butFrame, columnspan = 2, pady = 5)

    tkwait.window(base)

    return(args)
}
