# A widget for taking inputs for mergeSAGE.
#
# Copyright 2003, J. Zhang, all rights reserved
#

mergeSAGEWidget <- function(){
    on.exit(end())

    libNameVar <- tclVar(file.path(.path.package("SAGElyzer"), "temp"))
    isDirVar <- tclVar("TRUE")
    skipVar <- tclVar("0")
    patternVar <- tclVar(".sage")
    args <- NULL
    END <- TRUE

    end <- function(){
        tkdestroy(base)
    }
    cancel <- function(){
        END <<- FALSE
        end()
    }
    getLibNames <- function(){
        libNameVar <- paste(fileBrowser(path =
                            file.path(.path.package("SAGElyzer"), "temp")),
                            sep = "", collapse = ";")
        writeList(libEntry, libNameVar, TRUE)
    }


    base <- tktoplevel()
    tktitle(base) <- "BioC SAGElyzer"

    label2 <- tklabel(base, text = "Library")
    libFrame <- tkframe(base)
    libEntry <- tkentry(libFrame, width = 50, textvariable = libNameVar)
    tkpack(libEntry, side = "left", expand = TRUE, fill = "x")
    browseBut <- tkbutton(libFrame, width = 6, text = "Browse",
                                                 command =getLibNames)
    tkpack(browseBut, side = "left")
    tkgrid(label2, libFrame, padx = 5)

    label1 <- tklabel(base, text = "Directory")
    dirFrame <- tkframe(base)
    trueRad <- tkradiobutton(dirFrame, text = "TRUE", variable = isDirVar,
                             value = "TRUE")
    falseRad <- tkradiobutton(dirFrame, text = "FALSE",
                              variable = isDirVar, value = "FALSE")
    tkpack(trueRad, falseRad, side = "left")
    tkgrid(label1, dirFrame, padx = 5)

    label3 <- tklabel(base, text = "Skip")
    skipEntry <- tkentry(base, width = 50, textvariable = skipVar)
    tkgrid(label3, skipEntry, padx = 5)

    label4 <- tklabel(base, text = "Pattern")
    patternEntry <- tkentry(base, width = 50, textvariable = patternVar)
    tkgrid(label4, patternEntry, padx = 5)

    tkgrid.configure(label1, label2, label3, label4, sticky = "e")
    tkgrid.configure(dirFrame, libFrame, skipEntry, patternEntry,
                                                         sticky = "w")
    butFrame <- tkframe(base)
    cancelBut <- tkbutton(butFrame, text = "Cancel", width = 8,
                          command = cancel)
    endBut <- tkbutton(butFrame, text = "Continue", width = 8, command = end)
    tkpack(endBut, cancelBut, side = "left", padx = 20)
    tkgrid(butFrame, columnspan = 2, pady = 5)

    tkwait.window(base)
    if(END){
        args <- list(libNames = unlist(strsplit(tclvalue(libNameVar), ";")),
                     isDir = as.logical(tclvalue(isDirVar)),
                     skip = as.numeric(tclvalue(skipVar)))
        if(!any(tclvalue(patternVar) == c("", "NULL", "null", "NA", "na"))){
            args[["pattern"]] <- tclvalue(patternVar)
        }
    }

    return(args)
}
