\name{SAGEWidget}
\alias{SAGEWidget}
\alias{getTasks}
\alias{getDMProc}
\alias{getKNNProc}
\alias{butsInTBox}
\alias{getTaskTips}
\alias{KNNArgsWidget}
\title{A function that is the main interface for SAGElyzer}
\description{
  This function serves as the main interface for SAGElyzer, which
  contains buttons for making a connection to a database and invokes all
  the tasks and procedures to take to complete a task.
}
\usage{
SAGEWidget()
getTasks()
getDMProc(base, TBox, status)
getKNNProc(base, TBox, status)
butsInTBox(base, TBox, status, butList, clear = FALSE)
getTaskTips(task)
KNNArgsWidget()
}
\arguments{
  \item{base}{\code{base} a tkwin object that can be a parent of other
    widgets (e.g. window, frame)}
  \item{TBox}{\code{TBox} a tkwin object that can be used as a status bar}
  \item{status}{\code{status} a character string for the status of a process}
  \item{butList}{\code{butList} a list of chracter strings for function
    names. The name of the list will be used to create buttons baring
    the same name and values will be called when corresponding buttons
    are pressed} 
  \item{clear}{\code{clear} a boolean indicating if a status bar will be
    cleard before updating}
  \item{task}{\code{task} a character string for the name of a task of
    interest} 
}
\details{
  Each task may involve several procedures that require user inputs for
  arguments. Blanks need to be filled. Default values are provided
  whereever it is possible. Defaults are advised to be used if a user
  are not sure about what to enter for inputs.

  \code{\link{SAGEWidget}} calls the other functions listed in this man
  page.
}
\value{
  This function returns invisible().
}
\references{\url{http://www.ncbi.nlm.nih.gov/SAGE/}}
\author{Jianhua Zhang}
\note{This function is part of the Bioconductor poject at Dana-Farber
  Cancer Institute to provide Bioinformatics functionalities through R}

\examples{
if(interactive()){
    SAGEWidget()
}
}
\keyword{misc}
