\name{con4Win}
\alias{con4Win}
\alias{con4Unix}
\alias{makeConnection}
\alias{executeQuery}
\alias{query4Unix}
\alias{closeConn}
\alias{tableExists}
\title{Functions for database connection and manipulation}
\description{
  These functions make connections to or query against a database.
}
\usage{
con4Win(args)
con4Unix(args)
makeConnection(args)
executeQuery(sqlStat, conn, noReturn = FALSE)
query4Unix(sqlStat, conn, noReturn = FALSE)
closeConn(conn)
tableExists(conn, tableName)
}

\arguments{
  \item{args}{\code{args} a list of arguments that will be used for
    database connection and query}
  \item{sqlStat}{\code{sqlStat} a character string for the SQL statement
    to be sent to the database server}
  \item{conn}{\code{conn} a connection object}
  \item{noReturn}{\code{noReturn} a boolean to indicate whether a query
    sent to the database server will return any value}
  \item{tableName}{\code{tableName} a character string for the name of a
    database table}
}
\details{
  \code{\link{con4Win}} makes a connection to a database for windows.

  \code{\link{con4Unix}} makes a connection to a database for unix.

  \code{\link{makeConnection}} direct the effort of making a database
  connection depending on the platform.

  \code{\link{executeQuery}} executes a SQL query statement against a
    database.
  \code{\link{query4Unix}} executes a SQL query statement against a
    database under unix.

  \code{\link{closeConn}} closes a connection to a database.

  \code{\link{tableExists}} checks to see if a given table exists in the
  database. 
}
\value{
  \code{\link{con4Win}} returns an ODBC connection object.

  \code{\link{con4Unix}} returns an Rdbi connection object.

  \code{\link{makeConnection}} returns a connection object.

  \code{\link{executeQuery}} returns the values for a query.

  \code{\link{query4Unix}} returns the results of a query for unix.

  \code{\link{tableExists}} returns TRUE if a given table exists and
  FALSE otherwise.
}
\author{Jianhua Zhang}
\note{The functions are part of the Bioconductor project at Dana-Farber
  Cancer Institute to provide Bioinformatics functionalities through R}

\seealso{\code{\link{SAGELyzer}}, \code{\link{mergeSAGE}}}
\examples{
# No examples are given as database support will be required
}
\keyword{misc}
