\name{getTargetRow}
\alias{getTargetRow}
\title{Function that retrieves data from selected SAGE libraries for a
  given SAGE tag}
\description{
  Given a SAGE tag, this function queries an existing table in a
  database and retrieves data across all the selected SAGE libraies for
  that SAGE tag
}
\usage{
getTargetRow(dbArgs, conn, libs, tagColName, targetSAGE, what = "counts")
}
\arguments{
  \item{dbArgs}{\code{dbArgs} a list containing arguments needed to make
    connection to a database and queries against a table. The elements
    include a DSN under Windows and database name, user name, password,
    and host under Unix plus the names for three tables that will be
    used by functions of SAGElyzer}
  \item{conn}{\code{conn} a connection to a database}
  \item{libs}{\code{libs} a vector of character strings for column names
    of database table where SAGE library data are stored}
  \item{tagColName}{\code{tagColName} a character string for the column
    name of a database table where SAGE tags are stored}
  \item{targetSAGE}{\code{targetSAGE} a character string for the SAGE
    tag whose counts across SAGE libraries will be retrieved}
  \item{what}{\code{what} a character string that is either "counts",
    "info", or "map" to indicating the what database table to use}
}
\details{
  This function is called by \code{\link{SAGELyzer}} for the calculation
  of nearest neighbors for a given SAGE tag. It may not have much other
  practical use. 
}
\value{
  \code{\link{getTargetRow}} returns a vector containing the data
  retrieved 
}
\author{Jianhua Zhang}
\note{This function is part of the Bioconductor project at Dana-Farber
  Cancer Institute to provide Bioinformatics functionalities through R}

\examples{
  # No example is give as the function needs a database support
}
\keyword{manip}
