\name{querySAGE}
\alias{querySAGE}
\alias{getTableNames}
\alias{getColumnNames}
\title{Functions that provide an interface to allow users to query a SAGE
  library database table }
\description{
  These functions provides an interface for inputing query parameters
  for querying a table in a given database. Interface between R and
  the underlaying database management system is through Rdbi.
}
\usage{
querySAGE(args, dbObj = PgSQL())
getTableNames(args, dbObj)
getColumnNames(tableName, args, dbObj)
}

\arguments{
  \item{args}{\code{args} a list containing the arguments presented as
    name and value pairs. Valid element names include "dbname", "user",
    "password", "host", "hostaddr", and "port" }
  \item{dbObj}{\code{dbObj} a binding object for a given dbms
    (e. g. PgSQL() for postgreSQL)}
  \item{tableName}{\code{tableName} a character string for the name of a
    database table}
}
\details{
  \code{\link{getTableNames}} and \code{\link{getColumnNames}} get the
  names of selected database columns.
}
\value{
  \code{\link{getTableNames}} returns a vector of character strings for
  database table names.

  \code{\link{getColumnNames}} returns a vector of character strings for
  column names of a given database table.
}
\author{Jianhua Zhang}
\note{The functions are part of the Bioconductor project at Dana-Farber
  Cancer Institute to provide Bioinformatics functionalities through R}
\seealso{\code{\link{SAGE4Unix}}}
\examples{
# No example is provided as support of a database is required
}
\keyword{interface}

